<?php
/*
 * Autorun Manager 0.5
 * 2008 by Jeffri H <keaglez@gmail.com>
 *
 * Autorun Manager is a software for managing autorun files on Motorola ROKR E2 with custom firmware. It can edit autorun files with a user friendly interface. Autorun Manager support for creating, editing and viewing the autorun script. The autorun script is the custom script (default or) by user which will be loaded (only script in executed list) during boot time.
 * Autorun Manager was created from the idea of Faruq <www.aktaeon.com> and developed with show* binaries by him. The script was written by me, and presented for E2 Revival project.
 * Change log:
 * Version 0.5 (June 23, 2008)
    - written in pure PHP which is a lot faster than Bash shell
    - used show* binaries by Faruq with system call by show.php
    - edit features
    - view features
    - redesigned interface
    - all features from 0.3 version (ported to PHP)
 * Version 0.3 (February 26, 2008)
    - advanced creator of autorun script
    - used new show* binaries by Faruq with richer interface
 * Version 0.2 (February 9, 2008)
    - improved the creator of autorun script
  * Version 0.1 (January 11, 2008)
    - manage autorun with few click
    - creation of autorun script (basic)
    - delete autorun script with few click
*/

$mypath = dirname($_SERVER['PHP_SELF']);

// include classes and show
foreach (array("autorunmanager_class.php", "show.php", "kgapps.php") as $scp)
{
  if (! include("$scp"))
  {
    exec("showNotify -t \"Error\" -c \"Load $scp failed\"");
    die("Load $scp failed.\n");
  }
}

$perm = `whoami`;
if ($perm != "root\n")
{
  $error = new showQ("Error", "Not run as root, please give root permission.", 2);
  $error->exec() && die("Not run as root.");
}

// default config...
$autorun_dir = "/ezxlocal/.system/autorun";
$autorun_file = "/ezxlocal/autorun.txt";
$config = "$mypath/config.php";

// Autorun Manager main class for performing interface
class autorun_manager
{
  function __construct()
  {
    global $str;
    $this->menu = new showList($str[1], null, null, "'$str[3]' 'manage' '$str[4]' 'reorder' '$str[5]' 'view' '$str[6]' 'edit' '$str[7]' 'create' '$str[8]' 'delete' '$str[9]' 'properties' '$str[10]' 'setting' '$str[11]' 'help' '$str[2]' 'exit'", $str[2]);
  }
  function raise($ls)
  {
    // if pid was empty, run a new showList, else show the hidden showList...
    if (empty($this->menu->pid))
    {
      $this->menu->set_list($ls);
      $this->menu->run();
    }
    else
    {
      $this->menu->set_new_list($ls); // set new list...
      $this->menu->show(1); // pass 1 to run in background...increase speed a little...
    }
    return $this->menu->recv();
  }
  function manage($at, $af)
  {
    $manage = new manager($at, $af);
    $manage->run_manager();
  }
  function reorder($at, $af)
  {
    $reorder = new manager($at, $af);
    $reorder->run_reorder();
  }
  function view($file, $text)
  {
    global $str;
    $view = new showQ("$str[5]: $file", str_replace('$', '\$', $text), 2, null, $str[12]);
    $view->exec();
  }
  function edit($file)
  {
    $edit = new editor($file);
    $edit->run_editor();
  }
  function create()
  {
    global $autorun_dir;
    $new = "$autorun_dir/new_".date("Ymdhis").".lin";
    
    $create = new editor($new);
    $create->create_new();
  }
  function delete($file)
  {
    global $str;
    $del = new showQ($str[8], sprintf($str[27], basename($file)), 1);
    if ($del->exec() == 1)
    {
      unlink($file);
      if (! file_exists($file))
      {
        $stt = new showNotify($str[38], sprintf($str[37], basename($file)), 0);
        $stt->exec();
      }
      else
      {
        $stt = new showNotify($str[39], sprintf($str[40], basename($file)), 1);
        $stt->exec();
      }
    }
  }
  function properties($obj)
  {
    global $str;
    $info = new showQ($str[9], "$str[24]: ".$obj->get_title()."\n$str[29]: ".basename($obj->file)."\n$str[30]: ".filesize($obj->file)." bytes", 2, null, $str[12]);
    $info->exec();
  }
  function setting()
  {
    global $str, $mypath, $set;
    $stg = array($str[28] => "select_language", $str[31] => "select_autorun");
    $set->selector($stg, $str[10], null, $str[12]);
  }
  function help()
  {
    global $str, $help;
    $hlp = new showList($str[11], null, "'$str[3]' '$str[4]' '$str[5]' '$str[6]' '$str[7]' '$str[8]' '$str[9]' '$str[10]'", null, $str[12]);
    $ret = array(1, 1);
    while ($ret[1] != 0)
    {
      $ret = $hlp->exec();
      if ($ret[1] == 0)
        break;
      $show = new showQ($str[11], $help[$ret[1]], 2, null, $str[12]);
      $show->exec();
    }
  }
  function done()
  {
    $this->menu->done();
  }
}

class manager
{
  function __construct($at, $af)
  {
    $this->data = $at;
    $this->handler = $af;
  }
  function run_manager()
  {
    global $str;
    if (! isset($this->mgr))
      $this->mgr = new showMultiSelect($str[3], null, $this->read_list());
    $ret = $this->mgr->exec();
    if ($ret[0][0] != "Cancel!")
    {
      $this->set($ret[0]);
      $exec_ls = ereg_replace("^[']([^']*)['] *$", "> \\1" ,str_replace("' '", "\n> ", $this->read_exec()));
      $rp = new showQ($str[38], sprintf($str[35], $exec_ls), 2, null, $str[12]);
      $rp->exec();
    }
  }
  function run_reorder()
  {
    global $str;
    if (! isset($this->ord))
    {
      $this->ord = new showList($str[4], null, null, "'$str[12]' 'back'", $str[12]);
    }
    while (true)
    {
      $list_ex = $this->read_exec();
      if (empty($this->ord->pid))
      {
        $this->ord->set_list($list_ex);
        $this->ord->run();
      }
      else
      {
        $this->ord->set_new_list($list_ex);
        $this->ord->show(1);
      }
      $ret = $this->ord->recv();
      if ($ret[0] == "back")
      {
        $this->ord->done();
        break;
      }
      if ($ret[1] != 0)
      {
        $this->ord->show(1);
        $ret2 = $this->ord->recv();
        if ($ret2[0] == "back")
        {
          $this->ord->done();
          break;
        }
        if ($ret2[1] != 0)
          $this->handler->reorder(basename($this->exec[$ret[1]]->file), basename($this->exec[$ret2[1]]->file));
        else
          break;
      }
      else
        break;
    }
  }
  function read_list()
  {
    if (isset($this->stat))
      unset($this->stat);
    for ($c=1; $c <= count($this->data); $c++)
    {
      if (@in_array(basename($this->data[$c]->file), $this->handler->get_exec()))
        $this->stat[$c] = 1;
      else
        $this->stat[$c] = 0;
      $list .= "'".$this->data[$c]->get_title()."' ".$this->stat[$c]." ";
    }
    return $list;
  }
  function read_exec()
  {
    global $autorun_dir;
    if (isset($this->exec))
      unset($this->exec);
    $d = 0;
    foreach ($this->handler->get_exec() as $e)
    {
      $d++;
      $this->exec[$d] = new autorun("$autorun_dir/$e");
      $list .= "'".$this->exec[$d]->get_title()."' ";
    }
    return $list;
  }
  function set($arr)
  {
    for ($r=1; $r <= count($this->data); $r++)
    {
      if (strlen($r) == 1)
        $sel = "00$r";
      elseif (strlen($r) == 2)
        $sel = "0$r";
      if (in_array($sel, $arr))
      {
        if ($this->stat[$r] == 1)
          continue;
        else
          $this->handler->add(basename($this->data[$r]->file));
      }
      else
      {
        if ($this->stat[$r] == 0)
          continue;
        else
          $this->handler->remove(basename($this->data[$r]->file));
      }
    }
  }
}

class editor
{
  function __construct($file)
  {
    $this->file = $file;
    $f = 0;
    if ($openFile = @fopen($file, "r"))
    {
      while (! feof($openFile))
      {
        $f++;
        $getline = str_replace('$', '\$', fgets($openFile));
        $this->line[$f] = ereg_replace("\n$", "", $getline);
      }
      fclose($openFile);
    }
  }
  function run_editor()
  {
    global $str;
    if (! isset($this->edt))
    {
      $this->edt = new showList(basename($this->file), null, null, "'$str[13]' 'edit' '$str[14]' 'add' '$str[15]' 'remove' '$str[16]' 'save' '$str[17]' 'saveas'");
    }
    while (true)
    {
      if (empty($this->edt->pid))
      {
        $this->edt->set_list("'Loading...' '' '' '' '' '' '' '' '' '' '' '' ''");
        $this->edt->run();
        sleep(2);
      }
      $this->edt->set_new_list($this->read_line());
      $this->edt->show(1);
      $ret = $this->edt->recv();
      if (! empty($ret[0]))
        $this->edt->hide();
      if ($ret[1] != 0)
        $this->process($ret);
      else
        break;
      if ($ret[0] == "save" || $ret[0] == "saveas")
      {
        $this->edt->done();
        break;
      }
    }
  }
  function create_new()
  {
    global $str;
    $new = new showEntry($str[24], $str[25], 0, $str[26]);
    $ret = $new->exec();
    if ($ret[1] == 1)
    {
      $this->line[1] = "#!/bin/bash";
      $this->line[2] = "# Script created at ".date("Y-m-d");
      $this->line[3] = "";
      $this->line[4] = "title=\"$ret[0]\"";
      $this->line[5] = "";
      $this->line[6] = "# Your script here:";
      $this->line[7] = "";
      $this->run_editor();
    }
  }
  function read_line()
  {
    for ($i=1; $i <= count($this->line); $i++)
    {
      $ln = str_replace('"', '\"', $this->line[$i]);
      $ln = str_replace('`','\`', $ln);
      if (empty($ln))
        $ln = " ";
      $list .= '"'.$ln.'" ';
    }
    return $list;
  }
  function process($dt)
  {
    if ($dt[0] == "edit" || empty($dt[0]))
      $this->edit_line($dt[1]);
    elseif ($dt[0] == "add")
      $this->add_line($dt[1]);
    elseif ($dt[0] == "remove")
      $this->remove_line($dt[1]);
    elseif ($dt[0] == "save")
      $this->save($this->file);
    elseif ($dt[0] == "saveas")
      $this->saveas();
  }
  function edit_line($n)
  {
    global $str;
    $edit = new showEntry($str[13]);
    $txt = "";
    if ($n > 1)
      $txt .= "$str[18]:\n   ".$this->line[$n-1]."\n";
    if ($n < count($this->line))
      $txt .= "$str[19]:\n   ".$this->line[$n+1]."\n";
    $txt .= "$str[20]:\n   ".$this->line[$n];
    $edit->set_context($txt);
    $edit->set_default($this->line[$n]);
    $ret = $edit->exec();
    if ($ret[1] == 1)
    {
      if (ereg("\n$", $ret[0]))
        $ret[0] = ereg_replace("\n$", "", $ret[0]);
      $this->line[$n] = str_replace('$', '\$', $ret[0]);
    }
    else
      return false;
    return true;
  }
  function add_line($n)
  {
    if (isset($this->line[$n+1]))
    {
      for ($i = count($this->line); $i > $n; $i--)
      {
        $this->line[$i+1] = $this->line[$i];
      }
    }
    $this->line[$n+1] = " ";
    return true;
  }
  function remove_line($n)
  {
    global $str;
    if (count($this->line) == 1)
    {
      $err = new showNotify($str[21], $str[22]);
      $err->exec();
      return false;
    }
    if (isset($this->line[$n]))
    {
      for ($i = $n; $i < count($this->line); $i++)
      {
        $this->line[$i] = $this->line[$i+1];
      }
      unset($this->line[count($this->line)]);
    }
    return true;
  }
  function save($file)
  {
    global $str;
    if ($openFile = fopen($file, "w"))
    {
      foreach ($this->line as $wrt)
      {
        fwrite($openFile, str_replace('\$', '$', $wrt)."\n");
      }
      fclose($openFile);
      chmod($file, 0777);
    }
    if (file_exists($file))
    {
      $stt = new showNotify($str[38], sprintf($str[36], basename($file)), 0);
      $stt->exec();
    }
    else
    {
      $stt = new showNotify($str[39], sprintf($str[41], basename($file)), 1);
      $stt->exec();
    }
  }
  function saveas()
  {
    global $str, $autorun_dir;
    $svs = new showEntry($str[17], $str[23], 0, basename($this->file));
    $as = $svs->exec();
    if ($as[1] == 1)
    {
      if (! ereg("\.(lin|sh)$", $as[0]))
        $as[0] .= ".lin";
      $this->save("$autorun_dir/$as[0]");
    }
  }
}

class settings extends config
{
  function __construct($cfg)
  {
    config::__construct($cfg);
  }
  function select_language()
  {
    global $mypath, $str;
    $lng_path = "$mypath/langs";
    $l = 0;
    $list = "";
    foreach (scandir($lng_path) as $lng)
    {
      if ($lng == "." || $lng == ".." || ! ereg("\.php$", $lng))
        continue;
      if ($opn = fopen("$lng_path/$lng", "r"))
      {
        while (! feof($opn))
        {
          $getline = fgets($opn);
          if (ereg("^[$]language *= *['\"]([^'\"]*)['\"];", $getline, $get))
          {
            $l++;
            $list .= '"'.$get[1].'" ';
            $lang_name[$l] = $get[1];
            $lang[$l] = "$lng";
          }
        }
      }
    }
    $chg = new showList($str[28], null, $list, null, $str[12]);
    $ret = $chg->exec();
    if ($ret[1] != 0)
    {
      $this->set("langs", $lang[$ret[1]]);
      $pop = new showNotify($str[38], sprintf($str[32], $lang_name[$ret[1]]));
      $pop->exec();
    }
  }
  function select_autorun()
  {
    global $str;
    $list = array(
    1 => "/ezxlocal/autorun.txt",
    2 => "/mmc/mmca1/autorun.txt"
    );
    $sel = new showList($str[31], sprintf($str[43], $this->autorun_file), implode(" ", $list), null, $str[12]);
    $ret = $sel->exec();
    if ($ret[1] != 0)
    {
      $this->set("autorun_file", $list[$ret[1]]);
      $pop = new showNotify($str[38], sprintf($str[33], $list[$ret[1]]));
      $pop->exec();
    }
  }

}

// The main script start here..

while (true)
{
  if (isset($str))
    unset($str);
  // include config files...
  @include($config);
  // include language string...
  if (! @include("$mypath/langs/$langs"))
  {
    // if failed, include default language string (en.php)
    if (! @include("$mypath/langs/en.php"))
    {
      // if still failed, stop executing script and show error...
      $error = new showNotify("Fatal error", "Failed to load language string.", 1);
      $error->exec();
      die("Fatal error, failed to load language string.\n");
    }
  }

  $a = 0;
  $list = "";
  foreach (scandir($autorun_dir) as $file)
  {
    if ($file == "." || $file == "..")
      continue;
    if (! is_file("$autorun_dir/$file") || ! eregi("\.(lin|sh)$", $file))
      continue;
    $a++;
    $autorun[$a] = new autorun("$autorun_dir/$file");
    $list .= "'".$autorun[$a]->get_title()."' ";
  }

  if (! isset($set))
    $set = new settings($config);
  if ($set->langs != $langs)
  {
    $main->done();
    unset($main);
    unset($set);
    $reset = 1;
  }
  if ($set->autorun_file != $autorun_file)
  {
    unset($handler);
    unset($set);
    $reset = 1;
  }
  if ($reset == 1)
  {
    $set = new settings($config);
    $reset = 0;
  }
  if (! isset($main))
    $main = new autorun_manager();
  if (! file_exists($autorun_file))
    copy("$mypath/autorun.txt", $autorun_file) || die("Error, create $autorun_file failed.\n");
  if (! isset($handler))
    $handler = new manage($autorun_file);
  if (! $handler->check())
  {
    $pop = new showQ("$str[21]", sprintf($str[42], $autorun_file), 1);
    if ($pop->exec() == 1)
      $handler->fix($autorun_dir);
  }

  $ret = $main->raise($list, $show);
  $opt=$ret[0];
  $get=$ret[1];
  if (! empty($opt))
    $main->menu->hide();
  if ($get == 0 || $opt == "exit")
    break;
  if ($opt == "view" || empty($opt))
    $main->view(basename($autorun[$get]->file), $autorun[$get]->view);
  elseif ($opt == "manage")
    $main->manage($autorun, $handler);
  elseif ($opt == "reorder")
    $main->reorder($autorun, $handler);
  elseif ($opt == "edit")
    $main->edit($autorun[$get]->file);
  elseif ($opt == "create")
    $main->create();
  elseif ($opt == "delete")
    $main->delete($autorun[$get]->file);
  elseif ($opt == "properties")
    $main->properties($autorun[$get]);
  elseif ($opt == "setting")
    $main->setting();
  elseif ($opt == "help")
    $main->help();
}
$main->done();
exit(0);

?>
