<?php
/*
 * class.php for Autorun Manager 0.5
 * 2008 by Jeffri H <keaglez@gmail.com>
 */

// autorun classes to define autorun object, pass the autorun script (remember, full path) here...
class autorun
{
  function __construct($file)
  {
    $this->file = $file;
    if ($openFile = fopen($this->file, "r"))
    {
      $view = '';
      while (! feof($openFile))
      {
        $getLine = fgets($openFile);
//        if (ereg("^#.*$", $getLine))
//          continue;
        if (ereg("^title=['\"](.+)['\"].*$", $getLine, $get))
        {
          $this->title = $get[1]; // get the title here...
//          continue;
        }
        $view .= $getLine; // get the full script...
      }
      fclose($openFile);
      $this->view = $view;
    }
  }
  // method for view autorun script
  function view()
  {
    return $this->view;
  }
  // method for get the autorun script title
  function get_title()
  {
    return $this->title;
  }
  // method for reset
  function reset()
  {
    $this->__construct($this->file);
  }
}

// manage class to define the used autorun files object, pass the autorun file (remember, full path) here...
class manage
{
  function __construct($file)
  {
    if (! is_file($file))
      die("Error, $file is not a file.\n");
    $this->file = $file;
    if ($openFile = fopen($this->file, "r"))
    {
      $view = '';
      while (! feof($openFile))
      {
        $getLine = fgets($openFile);
        if (ereg("^exec=\(([^)]*)\).*$", $getLine, $get))
          $this->exec = $this->get_array($get[1]); // get exec list...
        $view .= $getLine;
      }
      $this->view = $view;
    }
    else
      die("Error, can't open $file.\n");
  }
  // method to initialize array
  function get_array($data)
  {
    if (empty($data))
      return 0;
    if ($data = ereg_replace("\"([^\"]*)\"[^\"]*", "\\1,", $data))
    {
      $data = ereg_replace(",$", "", $data);
      return explode(",", $data);
    }
  }
  // method to get exec list
  function get_exec()
  {
    return $this->exec;
  }
  // method to reset
  function reset()
  {
    $this->__construct($this->file);
  }
  // method to add script
  function add($script)
  {
    global $autorun_dir;
    if (! is_file("$autorun_dir/$script"))
      die("Error, $script file not found in $autorun_dir.\n");
    if ($this->exec != 0)
    {
      if (in_array($script, $this->exec))
        die("Error, $script already in list.\n");
    }
    $edit = $this->view;
    if ($this->exec == 0)
      $add = "\"$script\"";
    else
      $add = " \"$script\"";
    $edit = ereg_replace("(exec=\([^)]*)(\))", "\\1$add\\2", $edit);
    if ($openFile = fopen($this->file, "w"))
    {
      fwrite($openFile, $edit);
      fclose($openFile);
    }
    $this->reset();
  }
  // method to remove script
  function remove($script)
  {
    if (! in_array($script, $this->exec))
      die("Error, $script is not in list.\n");
    $edit = $this->view;
    $edit = ereg_replace(" *\"$script\"", "", $edit);
    $edit = ereg_replace("(exec=\() *", "\\1", $edit);
    if ($openFile = fopen($this->file, "w"))
    {
     fwrite($openFile, $edit);
     fclose($openFile);
    }
    $this->reset();
  }
  // method to reorder script
  function reorder($script1, $script2)
  {
    foreach (array($script1, $script2) as $s)
    {
      if (! in_array($s, $this->exec))
        die("Error, $s is not in the list.\n");
    }
    $edit = $this->view;
    if (ereg("exec=\([^)]*\"$script1\"[^)]*\"$script2\"[^)]*\)", $edit))
      $edit = ereg_replace("(exec=\([^)]*)(\"$script1\")([^)]*)(\"$script2\")([^)]*\))", "\\1\\4\\3\\2\\5", $edit);
    else
      $edit = ereg_replace("(exec=\([^)]*)(\"$script2\")([^)]*)(\"$script1\")([^)]*\))", "\\1\\4\\3\\2\\5", $edit);
    if ($openFile = fopen($this->file, "w"))
    {
      fwrite($openFile, $edit);
      fclose($openFile);
    }
    $this->reset();
  }
  // method to check autorun files
  function check()
  {
    $reg = " *exec=\([^)]*\) *;* *(\n)+ *autorun_dir=\"[^\"]+\" *;* *(\n)+ *for \(\(i=0 *; *[$]i<[$]\{#exec\[@\]\} *; *i\+\+\)\) *;* *(\n)* *do(\n)+\. *[$]autorun_dir/[$]\{exec\[i\]\} *;* *(\n)+ *done";
    if (ereg($reg, $this->view))
      return true;
    else
      return false;
  }
  function fix($dir)
  {
    if (! $this->check())
    {
      $str = "\n# Autorun Manager 0.5\nexec=()\nautorun_dir=\"$dir\";\n\nfor ((i=0; \$i<\${#exec[@]}; i++)); do\n. \$autorun_dir/\${exec[i]}\ndone\n";
      if ($openFile = fopen($this->file, "a"))
      {
        fwrite($openFile, $str);
        fclose($openFile);
      }
    }
    $this->reset();
  }
}
?>
