<?php
/*
 * kgapps.php
 *  2008 by Jeffri H <keaglez@gmail.com>
 * This file contain some useful classes for ROKR E2 development with PHP.
 */

/* config class, for read and change configuration in valid PHP files.
 * Usage:
 ** Create a child class for this config class with inheritance.
 ** Pass configuration files in constructor.
 ** To use selector method, pass an array with key as selection text and value as method to call.
 * Example code:
    class setup extends config
    {
      function __construct($cfg)
      {
        config::__construct($cfg); // call constructor
      }
      // method to call when "Some Setup" selected.
      function some_setup()
      {
        // some code here...
      }
    }
    $test = new setup("./config.php");
    $set = array("Some Setup" => "some_setup");
    $test->selector($set, "Setup", "Choose:");
 */

class config
{
  function __construct($cfg)
  {
    if ($opn = fopen($cfg, "r"))
    {
      while (! feof($opn))
      {
        $getline = fgets($opn);
        if (ereg("^[$]([^=]*) = [\"']([^\"']*)[\"'].*$", $getline, $get))
          $this->$get[1] = $get[2];
        $this->view .= $getline;
      }
      fclose($opn);
      $this->file = $cfg;
    }
  }
  function selector($ar, $title = "", $context = "", $rsk = "", $lsk = "")
  {
    reset($ar);
    $r = 0;
    $list = "";
    while ($kv = each($ar))
    {
      $r++;
      $this->menu[$r] = $kv[1];
      $list .= '"'.$kv[0].'" ';
    }
    $sel = new showList($title, $context, $list, null, $rsk, $lsk);
    $ret = $sel->exec();
    if ($ret[1] != 0)
    {
      $call = $this->menu[$ret[1]];
      $this->$call();
    }
  }
  function set($nm, $val)
  {
    if (ereg("[$]$nm", $this->view))
      $wrt = ereg_replace("([$]$nm *= *['\"])[^'\"]*(['\"];)", "\\1$val\\2", $this->view);
    else
      $wrt = ereg_replace("\?>", "\$$nm = \"$val\";\n?>", $this->view);
    if ($opn = fopen($this->file, "w"))
    {
      fwrite($opn, $wrt);
      fclose($opn);
    }
  }
}

?>