<?php
/*
 * show.php
 * 2008 by Jeffri H <keaglez@gmail.com>
 * This file contains object for using show* binaries by Faruq <www.aktaeon.com> which was created for Revival project
*/

/*
USAGE:
There is two possible way of using show* here, by passing argument to the constructor or by manually add with set_* method... However, for now, I didn't use constructor for set the icon yet...use set_icon method instead... The reason is because I want to focus constructor for data input only... Each action is described here...
*/

// Quotation is dangerous and here is a function to fix it...
function fix($tx)
{
  $tx = str_replace('"', '\"', $tx);
  $tx = str_replace('`', '\`', $tx);
//  $tx = str_replace("'", "\'", $tx);
  return $tx;
}

// This is the parent class show...it has few method that needed in all show*...note that some method is not available in some show*...
class show
{
  // method for set your title text...
  function set_title($title)
  {
    $this->title = ' -t "'.fix($title).'"';
  }
  // method for set your context...
  function set_context($text)
  {
    $this->context = ' -c "'.fix($text).'"';
  }
  // method for set icon, pass your icon directory here...
  function set_icon($icon)
  {
    $this->icon = " -i '$icon'";
  }
  // method for set right softkey text...
  function set_rsk($text)
  {
    $this->rsk = ' -rsk "'.fix($text).'"';
  }
  // method for set left softkey text...
  function set_lsk($text)
  {
    $this->lsk = ' -lsk "'.fix($text).'"';
  }
  // this method used for constructor of other child class...
  function multi_set($t = "", $c = "", $r = "", $l = "")
  {
    if (! empty($t))
      $this->set_title($t);
    if (! empty($c))
      $this->set_context($c);
    if (! empty($r))
      $this->set_rsk($r);
    if (! empty($l))
      $this->set_lsk($l);
  }
}

// showList is for showing list of menus...it includes the capability for options and it can be controlled while it runs...
// more information: showList --help (in your shell)
class showList extends show
{
  // constructor, pass with: title, context, list, option, right softkey, left softkey
  // pass a null or empty string "" for an optional argument (option, rsk, lsk) that u dont want to set, but u want to set the one in left of the argument...
  // ex: new showList("title", "some text", "list1 list2 list3", null, "Exit");
  function __construct($t = "", $c = "", $ls = "", $op = "", $r = "", $l = "")
  {
    $this->multi_set($t, $c, $r, $l);
    if (! empty($op))
      $this->set_option($op);
    if (! empty($ls))
      $this->set_list($ls);
  }
  // method for set option, the option list should use this scheme: 'text' 'print' for each option... (note that single quote or double quote is important if you want to have space in it, be careful of using quotation)
  // 'text' is the displayed text in options...
  // 'print' is the printed text for this option...it also accept executing command by using 'exec:your_command'
  function set_option($opt_list)
  {
    $this->option = " -menustart $opt_list -menuend";
  }
  // method for set list, separate each list by space... (use quotation for whitespace in your list)
  function set_list($main_list)
  {
    $this->list = " $main_list";
  }
  // exec method will run showList and wait until it done...the return of exec is an array with two values, the 0 key for the printed text and the 1 key for the return value...
  // printed text is useful to maintain options...
  // the return value is the number of selected menu...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showList".$this->title.$this->icon.$this->context.$this->rsk.$this->lsk.$this->option.$this->list, $exec, $ret);
    return array(implode("\n", $exec), $ret);
  }
  // run method will run showList and continue your code...it will generate pid to use in other method...
  function run($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showList".$this->title.$this->icon.$this->context.$this->rsk.$this->lsk.$this->option.$this->list." > /dev/null &");
    $run = `pidof showList`;
    ereg("^([0-9]+)", $run, $get); // we get the first pid here, because the newest pid of showList will show first...
    $this->pid = $get[1];
    if (empty($this->pid))
      return false;
    return true;
  }
  // recv method is used to receive information of showList...
  // after run it will wait until it got the return value from showList...
  function recv()
  {
    if (! empty($this->pid))
    {
      $pid = `pidof showList`;
      if (ereg($this->pid, $pid))
        exec("listRecv ".$this->pid, $opt, $get); // if pid still exist, we run listRecv
      else
        return false;
    }
    else
      return false;
    return array(implode("\n", $opt), $get);
  }
  // this method is used to run listCmd from other methods...
  // pass second argument to 1 will make it run in background...this might improve the speed of your script...or avoid the unnecessary load and continue the script...
  function cmd($com, $r = 0)
  {
    if ($r == 1)
      $com .= " > /dev/null &";
    if (! empty($this->pid))
    {
      $pid = `pidof showList`;
      if (ereg($this->pid, $pid))
        exec("listCmd ".$this->pid." $com");
    }
    else
      return false;
    return true;
  }
  // method for set new list... Pass the second argument to 1 to run in background...
  function set_new_list($new, $r = 0)
  {
    return $this->cmd("setlist ".$new, $r);
  }
  // method for show showList if its hide, pass 1 as argument to run in background...
  function show($r = 0)
  {
    return $this->cmd("show", $r);
  }
  // method for hide the showList...pass 1 as argument to run in background...
  function hide($r = 0)
  {
    return $this->cmd("hide", $r);
  }
  // method for close showList... Pass 1 as argument to run in background...
  function done($r = 0)
  {
    return $this->cmd("done", $r);
  }
}

// showQ is used to show text with two possible return by the softkey...
// showQ support 4 types and possible to change the softkey text...
class showQ extends show
{
  // constructor, pass argument with: title, context, type (integer), right softkey, left softkey
  function __construct($t = "", $c = "", $p = 0, $rsk = "", $lsk = "")
  {
    $this->multi_set($t, $c, $rsk, $lsk);
    $this->set_type($p);
  }
  // default is 0 which shows Ok/Cancel...other possible value: 1 for Yes/No, 2 for Ok only, 3 for no text...it also shows different icon for each...
  // however, the softkey and the icon can be changed...
  function set_type($p)
  {
    $this->type = " -p $p";
  }
  // exec and wait until it returns...
  // return 1 for left sofkey and 0 for right softkey...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showQ".$this->title.$this->icon.$this->context.$this->lsk.$this->rsk.$this->type, $opt, $ret);
    return $ret;
  }
}

// showNotify is for show a notify box...
class showNotify extends show
{
  // constructor, pass with: title, context, type (integer), time (integer, second)
  function __construct($t = "", $c = "", $p = 0, $s = "")
  {
    $this->multi_set($t, $c);
    $this->set_type($p);
    if (! empty($s))
      $this->set_timer($s);
  }
  // dialog type, 0 for okay, 1 for info and 2 for no icon...however, icon can be changed...
  function set_type($p)
  {
    $this->type = " -p $p";
  }
  // set how long the time for showNotify to show (if not interruped by the user)...in seconds...
  function set_timer($s)
  {
    $this->timer = " -s $s";
  }
  // exec showNotify, no returns value here...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showNotify".$this->title.$this->icon.$this->context.$this->type.$this->timer);
  }
}

// showEntry is for show a text box and receive input from user...
// showEntry support two types, default text and even regex (regular expression)...
class showEntry extends show
{
  // constructor, pass with: title, context, type (integer), default text, regex
  function __construct($t = "", $c = "", $p = 0, $d = "", $r = "")
  {
    $this->multi_set($t, $c);
    $this->set_type($p);
    if (! empty($d))
      $this->set_default($d);
    if (! empty($r))
      $this->set_regex($r);
  }
  // there are two possible type, 0 for normal and 1 for password...
  function set_type($p)
  {
    $this->type = " -p '$p'";
  }
  // default text will show as default and highlighted in text box...
  function set_default($text)
  {
    $this->default = ' -d "'.fix($text).'"';
  }
  // regex will check for correct regex before return the text...
  function set_regex($reg)
  {
    $this->regex = ' -r "$reg"';
  }
  // run the showEntry and return an array with 0 key as the input text from user, and 1 key for the returned value...
  // return value is 1 for accepted and 0 for rejected...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showEntry".$this->title.$this->icon.$this->context.$this->default.$this->regex.$this->type, $print, $ret);
    return array(implode("\n", $print), $ret);
  }
}

// showMultiSelect is for show a multi selection box...
class showMultiSelect extends show
{
  // constructor, pass with: title, context, list
  function __construct($t = "", $c = "", $ls = "")
  {
    $this->multi_set($t, $c);
    $this->set_list($ls);
  }
  // set list, use this scheme: 'text' 0/1
  // 0 for unchecked and 1 for checked...
  function set_list($multi_list)
  {
    $this->list = " $multi_list";
  }
  // run showMultiSelect and return an array contains:
  // 0 key for array of selected list...
  // 1 key for the amount of selected list...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showMultiSelect".$this->title.$this->icon.$this->context.$this->list, $select, $ret);
    return array($select, $ret);
  }
}

// showProgress is to show a progress bar...
// interesting part here is the progress bar can be controlled...
class showProgress extends show
{
  // constructor, pass with: title, context
  function __construct($t = "", $c = "")
  {
    $this->multi_set($t, $c);
  }
  // exec showProgress...it will run in background...also it generates pid for used by other methods...
  // no returns value here...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showProgress".$this->title.$this->context." > /dev/null &");
    sleep(2);
    $run = `pidof showProgress`;
    ereg("^([0-9]+)", $run, $get);
    $this->pid = $get[1];
    if (empty($this->pid))
      return false;
    return true;
  }
  // method for run listCmd with specified argument...
  function cmd($com)
  {
    if (! empty($this->pid))
    {
      $pid = `pidof showProgress`;
      if (ereg($this->pid, $pid))
        exec("progressCmd ".$this->pid." $com");
      else
        return false;
    }
    else
      return false;
    return true;
  }
  // increase bar, pass the number of bar you like to increase...default is 1...
  function increase($c = 1)
  {
    for ($i = 0; $i < $c; $i++)
    {
      $this->cmd("increase");
    }
  }
  // the opposite of increase...
  function decrease($c = 1)
  {
    for ($i = 0; $i < $c; $i++)
    {
      $this->cmd("decrease");
    }
  }
  // show the progress box if hide...
  function show()
  {
    return $this->cmd("show");
  }
  // hide the progress box...
  function hide()
  {
    return $this->cmd("hide");
  }
  // finish the progress box...
  function done()
  {
    return $this->cmd("done");
  }
}

// showNumPicker for show a number selector box...
// support for default, minimum, maximum and increment number...
class showNumPicker extends show
{
  // constructor, pass with: title, default (int), minimum (int), maximum (int), increment (int)
  function __construct($t = "", $d = 0, $n = 0, $m = 100, $r = 1)
  {
    $this->set_title($t);
    $this->set_default($d);
    $this->set_min($n);
    $this->set_max($m);
    $this->set_increment($r);
  }
  // default number...
  function set_default($d)
  {
    $this->default = " -d $d";
  }
  // minimum number...
  function set_min($n)
  {
    $this->min = " -n $n";
  }
  // maximum number...
  function set_max($m)
  {
    $this->max = " -m $m";
  }
  // increment number...
  function set_increment($r)
  {
    $this->increment = " -r $r";
  }
  // run showNumPicker and return array containing selected number and return value...
  // possible return value is 0 for rejected and 1 for accepted...
  function exec($ly = 1)
  {
    if ($ly == 1)
      ZAppLayer();
    exec("showNumPicker".$this->title.$this->icon.$this->context.$this->default.$this->min.$this->max.$this->increment, $num, $ret);
    return array(implode("\n", $num), $ret);
  }
}

// App layer to run in background... Pass 0 in every exec method for disable it...
function ZAppLayer()
{
  $pid = `pidof ZAppLayer`;
  if (! ereg("[0-9]+", $pid))
  {
    exec("ZAppLayer ".getmypid()." > /dev/null &");
    sleep(1);
  }
}

?>